package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.WFAssistWorkMapper;
import com.sa.ibiz.demo.demo.domain.WFAssistWork;
import com.sa.ibiz.demo.demo.service.WFAssistWorkService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.WFAssistWorkSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.WFInstanceService;
import com.sa.ibiz.demo.demo.service.WFStepActorService;
import com.sa.ibiz.demo.demo.service.WFWorkflowService;

/**
 * 实体[WFAssistWork] 服务对象接口实现
 */
@Service
public class WFAssistWorkServiceImpl extends ServiceImplBase<WFAssistWorkMapper, WFAssistWork> implements WFAssistWorkService{

    @Autowired
    private WFInstanceService wfinstanceService;
    @Autowired
    private WFStepActorService wfstepactorService;
    @Autowired
    private WFWorkflowService wfworkflowService;

    @Resource
    private WFAssistWorkMapper wfassistworkMapper;


    @Override
    public boolean create(WFAssistWork et) {
        this.beforeCreate(et);
         return super.create(et);
    }
    @Override
    public boolean update(WFAssistWork et){
        this.beforeUpdate(et);
		this.wfassistworkMapper.updateOne(et);
		this.get(et);
		return true;
    }

    public Object getEntityKey(WFAssistWork et){
		return et.getWfassistworkid();  
    }

    @Override
    public boolean getDraft(WFAssistWork et)  {
    if((!StringUtils.isEmpty(et.getWfinstanceid())) && et.getWfinstance() == null){
            try {
                et.setWfinstance(wfinstanceService.getById(et.getWfinstanceid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getWfstepactorid())) && et.getWfstepactor() == null){
            try {
                et.setWfstepactor(wfstepactorService.getById(et.getWfstepactorid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getWfworkflowid())) && et.getWfworkflow() == null){
            try {
                et.setWfworkflow(wfworkflowService.getById(et.getWfworkflowid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<WFAssistWork> listCurUserAssistWork(WFAssistWorkSearchFilter filter) {
		return wfassistworkMapper.searchCurUserAssistWork(filter,filter.getSelectCond());
	}

	public Page<WFAssistWork> searchCurUserAssistWork(WFAssistWorkSearchFilter filter) {
		return wfassistworkMapper.searchCurUserAssistWork(filter.getPage(),filter,filter.getSelectCond());
	}


	public List<WFAssistWork> listDefault(WFAssistWorkSearchFilter filter) {
		return wfassistworkMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<WFAssistWork> searchDefault(WFAssistWorkSearchFilter filter) {
		return wfassistworkMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return wfassistworkMapper.selectRow(sql);
    }

 }